SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

Interval subclass: #MeasureInterval
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'Raul 6/2/2012 13:58'!
by
	
	^step
! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'Raul 6/2/2012 13:58'!
from
	
	^start! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 15:45'!
last
	
	^stop! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'Raul 6/2/2012 13:58'!
size
	
	start = stop
		ifTrue: [^1] 
		ifFalse: [^1+((start + step) to: stop by: step) size]
! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'Raul 6/2/2012 13:57'!
to
	
	^stop! !

Magnitude subclass: #Measure
	instanceVariableNames: 'unit amount domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Measure subclass: #CompoundMeasure
	instanceVariableNames: 'firstUnit secondUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!CompoundMeasure class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/2/2012 18:27'!
newWithAmount: anAmount unit: aUnit operation: anOperation otherUnit: anOtherUnit

	|aCompoundMeasure|
	
	aCompoundMeasure := self new.
	^aCompoundMeasure initializeWithAmount: anAmount unit: aUnit operation: anOperation otherUnit: anOtherUnit! !

Measure subclass: #Distance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Distance class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/23/2012 11:54'!
newWithAmount: anAmount unit: aUnit

	|aDistance|
	
	aDistance := self new.
	^aDistance initializeWithAmount: anAmount unit: aUnit! !

!Distance methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/23/2012 12:44'!
+ aDistance
	|aBasicUnit|
	
	aBasicUnit := Unit meter.
	^Distance newWithAmount: ((self convertTo: aBasicUnit) amount + (aDistance convertTo: aBasicUnit) amount) unit: aBasicUnit! !

!Distance methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/23/2012 12:08'!
- aDistance
	
	^ self + aDistance negated! !

!Distance methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/21/2012 21:01'!
amount 
	
	^amount.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'Raul 6/2/2012 12:26'!
basicUnit 

	^Unit meter		! !

!Distance methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/23/2012 18:36'!
compare: aDistance by: anOperation

	self anOperation aDistance ifTrue: [^self].
	^aDistance
		! !

!Distance methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/23/2012 20:03'!
compareWith: aDistance by: anOperation

	self anOperation aDistance ifTrue: [^self].
	^aDistance
		! !

!Distance methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/23/2012 11:54'!
initializeWithAmount: anAmount unit: aUnit

	amount := anAmount.
	unit := aUnit.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/23/2012 12:21'!
negated 
	
	^self * -1! !

!Distance methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/23/2012 11:39'!
printOn: aStream 
	|text|

	text := amount printString , ' ' , unit printString.
	(amount=1) ifFalse: [text := text , 's'].
	
	aStream nextPutAll: text
	! !

!Distance methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/21/2012 19:44'!
unit 
	
	^unit.! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 14:42'!
newWithAmount: anAmount unit: aUnit

	(aUnit isKindOf: Unit) 
		ifTrue: [^self new initializeWithAmount: anAmount unit: aUnit]
		ifFalse: [^anAmount]! !

!Measure methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 12:27'!
* aMultiplier
	
	(aMultiplier isKindOf: Measure) 
		ifTrue: [^Measure newWithAmount: (self amount * aMultiplier amount) unit: (self unit * aMultiplier unit)]
		ifFalse: [^self class newWithAmount: aMultiplier * amount unit: unit]
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 11:48'!
+ aMeasure
	
	^self class newWithAmount: (unit convertionFromBaseFunction value: ((unit convertionToBaseFunction value: amount) + (aMeasure unit convertionToBaseFunction value: aMeasure amount))) unit: unit ! !

!Measure methodsFor: 'as yet unclassified' stamp: 'Raul 6/2/2012 13:19'!
- aMeasure 
	
	^ self + aMeasure negated! !

!Measure methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 14:36'!
/ aDevider
	
	(aDevider isKindOf: Measure) 
		ifTrue: [^Measure newWithAmount: (self amount * aDevider amount) unit: (self unit / aDevider unit)]
		ifFalse: [^self class newWithAmount: amount / aDevider unit: unit]
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 11:48'!
< aMeasure

	^(unit convertionToBaseFunction value: amount)  < (aMeasure unit convertionToBaseFunction value: aMeasure amount )
		! !

!Measure methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 15:41'!
= aMeasure
 
	((aMeasure isKindOf: Measure) and: [self unit domain == aMeasure unit domain]) 
		ifTrue: [^(unit convertionToBaseFunction value: amount) == (aMeasure unit convertionToBaseFunction value: aMeasure amount)] 		
		ifFalse: [^false]
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/2/2012 18:10'!
adaptToInteger: aNumber andSend: aMessage
	
	^self perform: aMessage with: aNumber! !

!Measure methodsFor: 'as yet unclassified' stamp: 'Raul 6/2/2012 11:10'!
amount 
	
	^amount.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'Raul 6/2/2012 12:25'!
basicUnit
	
	^self subclassResponsibility! !

!Measure methodsFor: 'as yet unclassified' stamp: 'Raul 6/2/2012 14:00'!
compare: aDistance by: anOperation

	self anOperation aDistance ifTrue: [^self].
	^aDistance
		! !

!Measure methodsFor: 'as yet unclassified' stamp: 'Raul 6/2/2012 14:00'!
compareWith: aDistance by: anOperation

	self anOperation aDistance ifTrue: [^self].
	^aDistance
		! !

!Measure methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 11:48'!
convertTo: aUnit

	self unit type == aUnit type
		ifTrue: [^self class newWithAmount: ( aUnit convertionFromBaseFunction value: (unit convertionToBaseFunction value: amount) ) unit: aUnit]
		 ifFalse: [Notification signal: 'No se puede convertir la medida a la unidad pedida']! !

!Measure methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 11:48'!
hash
	
	^(unit convertionToBaseFunction value: amount) hash! !

!Measure methodsFor: 'as yet unclassified' stamp: 'Raul 6/2/2012 11:10'!
initializeWithAmount: anAmount unit: aUnit

	amount := anAmount.
	unit := aUnit.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'Raul 6/2/2012 11:13'!
negated 
	
	^self * -1! !

!Measure methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/2/2012 17:08'!
printOn: aStream 
	|text|

	text := amount printString , ' ' , unit printString.
	((amount=1) or: [unit printString = 'celsius']) ifFalse: [text := text , 's'].
	
	aStream nextPutAll: text
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'Raul 6/2/2012 14:01'!
to: stopMeasure

	^MeasureInterval from: self to: stopMeasure by: (self class newWithAmount: 1 unit: (self unit min: stopMeasure unit))! !

!Measure methodsFor: 'as yet unclassified' stamp: 'Raul 6/2/2012 14:00'!
to: stopMeasure by: aMeasure

	^MeasureInterval from: self to: stopMeasure by: aMeasure! !

!Measure methodsFor: 'as yet unclassified' stamp: 'Raul 6/2/2012 11:10'!
unit 
	
	^unit.! !

Measure subclass: #Temperature
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Temperature methodsFor: 'as yet unclassified' stamp: 'Raul 6/2/2012 14:03'!
basicUnit 

	^Unit celsius.		! !

Measure subclass: #TimeMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'IgalFrid 6/2/2012 17:42'!
canNotConvertMeasurementException
	
	"self error: 'Este metodo debe devolver el objeto que representa que no se pudo
		convertir una medida a la unidad pedida'"
		
	^Notification signal: 'No se puede convertir la medida a la unidad pedida'! !

!MeasureTest methodsFor: 'temperature units' stamp: 'Raul 6/2/2012 14:03'!
celsius
	
	^Unit celsius .! !

!MeasureTest methodsFor: 'distance units' stamp: 'Raul 6/2/2012 14:03'!
centimeter
	
	^Unit centimeter .! !

!MeasureTest methodsFor: 'time units' stamp: 'Raul 6/2/2012 14:06'!
day
	
	^Unit day.! !

!MeasureTest methodsFor: 'distance units' stamp: 'Raul 6/2/2012 14:04'!
decameter
	
	^Unit decameter.! !

!MeasureTest methodsFor: 'distance units' stamp: 'Raul 6/2/2012 14:04'!
decimeter
	
	^Unit decimeter .! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'IgalFrid 6/3/2012 13:03'!
eightCubicMeters

	^Measure newWithAmount: 8 unit: Unit cubicMeter! !

!MeasureTest methodsFor: 'temperature units' stamp: 'Raul 6/2/2012 14:04'!
fahrenheit
	
	^Unit fahrenheit .! !

!MeasureTest methodsFor: 'compound measures' stamp: 'IgalFrid 6/3/2012 15:09'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod

	"^self error: 'Implementar la formula de velocidad final: vf = vi + a * t'"
	 ^initialSpeed + (anAcceleration * aTimePeriod)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'IgalFrid 6/3/2012 13:00'!
fourSquaredMeters

	^Measure newWithAmount: 4 unit: Unit squaredMeter! !

!MeasureTest methodsFor: 'distance units' stamp: 'Raul 6/2/2012 14:04'!
hectometer
	
	^Unit hectometer .! !

!MeasureTest methodsFor: 'time units' stamp: 'Raul 6/2/2012 14:05'!
hour
	
	^Unit hour .! !

!MeasureTest methodsFor: 'temperature units' stamp: 'Raul 6/2/2012 14:05'!
kelvin
	
	^Unit kelvin .! !

!MeasureTest methodsFor: 'distance units' stamp: 'Raul 6/2/2012 14:05'!
kilometer
	
	^Unit kilometer .! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'Raul 6/2/2012 14:05'!
meter

	^Unit  meter .! !

!MeasureTest methodsFor: 'distance units' stamp: 'Raul 6/2/2012 14:05'!
millimeter
	
	^Unit  milimeter .! !

!MeasureTest methodsFor: 'distance measures' stamp: 'Raul 6/2/2012 14:07'!
minusOneMeter 
	
	^Distance newWithAmount: -1 unit: self meter .! !

!MeasureTest methodsFor: 'time units' stamp: 'Raul 6/2/2012 14:05'!
minute
	
	^Unit minute.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'IgalFrid 6/2/2012 16:31'!
oneCelsius
	
	^Temperature newWithAmount: 1 unit: Unit celsius.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'Raul 6/2/2012 14:07'!
oneCentimeter
	
	^Distance newWithAmount: 1 unit: Unit centimeter .! !

!MeasureTest methodsFor: 'time measures' stamp: 'IgalFrid 6/2/2012 16:28'!
oneDay
	
	^TimeMeasure newWithAmount: 1 unit: Unit day! !

!MeasureTest methodsFor: 'time measures' stamp: 'IgalFrid 6/2/2012 16:28'!
oneHour
	
	^TimeMeasure newWithAmount: 1 unit: Unit hour! !

!MeasureTest methodsFor: 'distance measures' stamp: 'IgalFrid 6/2/2012 16:27'!
oneHundredCentimeters
	
	^Distance newWithAmount: 100 unit: Unit centimeter ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'IgalFrid 6/3/2012 15:04'!
oneHundredTwentyOneMetersPerSecond

	"^self error: 'este metodo debe devolver la medida 121 metro/segundo'"
	^Measure newWithAmount: 121 unit: Unit metersBySecond! !

!MeasureTest methodsFor: 'distance measures' stamp: 'IgalFrid 6/2/2012 16:27'!
oneMeter
	
	^Distance newWithAmount: 1 unit: Unit meter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'IgalFrid 6/3/2012 13:12'!
oneMeterPerSecond

	^Measure newWithAmount: 1 unit: Unit metersTimesSecond 
! !

!MeasureTest methodsFor: 'time measures' stamp: 'IgalFrid 6/2/2012 16:29'!
oneMinute
	
	^TimeMeasure newWithAmount: 1 unit: Unit minute ! !

!MeasureTest methodsFor: 'time measures' stamp: 'IgalFrid 6/2/2012 16:23'!
oneSecond

	^TimeMeasure newWithAmount: 1 unit: Unit second! !

!MeasureTest methodsFor: 'compound measures' stamp: 'IgalFrid 6/3/2012 12:29'!
oneSquaredMeter

	^Measure newWithAmount: 1 unit: Unit squaredMeter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'IgalFrid 6/3/2012 12:29'!
oneSquaredSecond

	^Measure newWithAmount: 1 unit: Unit squaredSecond! !

!MeasureTest methodsFor: 'time units' stamp: 'Raul 6/2/2012 14:07'!
second
	
	^Unit second .! !

!MeasureTest methodsFor: 'time measures' stamp: 'IgalFrid 6/2/2012 16:29'!
sixtyMinutes
	
	^TimeMeasure newWithAmount: 60 unit: Unit minute ! !

!MeasureTest methodsFor: 'time measures' stamp: 'IgalFrid 6/2/2012 16:29'!
sixtyOneSeconds
	
	^TimeMeasure newWithAmount: 61 unit: Unit second! !

!MeasureTest methodsFor: 'time measures' stamp: 'IgalFrid 6/2/2012 16:29'!
sixtySeconds
	
	^TimeMeasure newWithAmount: 60 unit: Unit second! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:05'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:11'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'milimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'IgalFrid 6/2/2012 17:09'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:19'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self oneMeter / self twoSeconds) = self twoMetersBySecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'IgalFrid 6/2/2012 16:31'!
thirtyTwoFahrenheits
	
	^Temperature newWithAmount: 32 unit: Unit fahrenheit! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'IgalFrid 6/2/2012 16:30'!
twentyFourHours
	
	^TimeMeasure newWithAmount: 24 unit: Unit hour! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'IgalFrid 6/2/2012 16:31'!
twoCelsius
	
	^Temperature newWithAmount: 2 unit: Unit celsius.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'IgalFrid 6/2/2012 16:26'!
twoHundredCentimeters 
	
	^Distance newWithAmount: 200 unit: Unit centimeter ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'IgalFrid 6/2/2012 16:25'!
twoMeters
	
	^Distance newWithAmount: 2 unit: Unit meter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'IgalFrid 6/3/2012 13:14'!
twoMetersBySecond

	^Measure newWithAmount: 2 unit: Unit metersBySecond! !

!MeasureTest methodsFor: 'compound measures' stamp: 'IgalFrid 6/3/2012 15:03'!
twoMetersPerSquaredSecond

	"^self error: 'este metodo debe devolver la medida 2 metros/segundoAlCuadrado'"
	 ^Measure newWithAmount: 2 unit: Unit metersBySquaredSecond! !

!MeasureTest methodsFor: 'compound measures' stamp: 'IgalFrid 6/3/2012 13:04'!
twoMetersTimesSecond

	^Measure newWithAmount: 2 unit: Unit metersTimesSecond! !

!MeasureTest methodsFor: 'time measures' stamp: 'IgalFrid 6/2/2012 16:30'!
twoSeconds
	
	^TimeMeasure newWithAmount: 2 unit: Unit second! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'IgalFrid 6/2/2012 16:31'!
zeroCelsius
	
	^Temperature newWithAmount: 0 unit: Unit celsius.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'IgalFrid 6/2/2012 16:32'!
zeroKelvin
	
	^Temperature newWithAmount: 0 unit: Unit kelvin! !

!MeasureTest methodsFor: 'distance measures' stamp: 'IgalFrid 6/2/2012 16:25'!
zeroMeters
	
	^Distance newWithAmount: 0 unit: Unit meter! !

!MeasureTest methodsFor: 'time measures' stamp: 'IgalFrid 6/2/2012 16:30'!
zeroSeconds
	
	^TimeMeasure newWithAmount: 0 unit: Unit second! !

Object subclass: #Unit
	instanceVariableNames: 'domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Unit subclass: #CompoundUnit
	instanceVariableNames: 'firstUnit secondUnit operator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!CompoundUnit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 12:02'!
newWithFirstUnit: firstUnit secondUnit: secondUnit operator: operator

	^self new initializeWithFirstUnit: firstUnit secondUnit: secondUnit operator: operator! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 11:51'!
= aUnit

	^ (aUnit isKindOf: #CompoundUnit) 
		ifTrue: [^(self firstUnit = aUnit firstUnit) and: [self secondUnit = self secondUnit]] 
		ifFalse: [^false]! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 12:57'!
convertionFromBaseFunction 

	^firstUnit convertionFromBaseFunction  ! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 12:59'!
convertionToBaseFunction

	^firstUnit convertionToBaseFunction  ! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 11:52'!
firstUnit

	^firstUnit 
! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 12:06'!
initializeWithFirstUnit: afirstUnit secondUnit: asecondUnit operator: anOperator

	firstUnit := afirstUnit.
	secondUnit := asecondUnit.
	operator := anOperator.
	! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 12:16'!
name

	^ firstUnit name, operator, secondUnit name! !

!CompoundUnit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 11:52'!
secondUnit

	^secondUnit 
! !

Unit subclass: #SimpleUnit
	instanceVariableNames: 'name convertionToBaseFunction convertionFromBaseFunction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!SimpleUnit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:28'!
newWithName: aName domain: aDomain convertionToBaseAs: aFunctionBlock convertionFromBaseAs: anotherFunctionBlock 
	
	^self new initializeWithName: aName type: aDomain convertionToBaseAs: aFunctionBlock convertionFromBaseAs: anotherFunctionBlock! !

!SimpleUnit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 11:48'!
= aUnit

	^((self convertionToBaseFunction value: 1) = ((aUnit convertionToBaseFunction) value: 1)) 
		and: [(self convertionFromBaseFunction value: 1) = ((aUnit convertionFromBaseFunction) value: 1)]
		and: [self name = (aUnit name)].
	
	! !

!SimpleUnit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 11:48'!
convertionFromBaseFunction 

	^convertionFromBaseFunction   ! !

!SimpleUnit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 11:48'!
convertionToBaseFunction 

	^convertionToBaseFunction   ! !

!SimpleUnit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:24'!
initializeWithName: aName type: aType convertionToBaseAs: aFunctionBlock convertionFromBaseAs: anotherFunctionBlock

	convertionToBaseFunction := aFunctionBlock.
	convertionFromBaseFunction := anotherFunctionBlock.
	domain := aType.
	name := aName! !

!SimpleUnit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/2/2012 18:57'!
name

	^name! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:28'!
celsius

	^SimpleUnit newWithName: 'celsius' domain: #Temperature convertionToBaseAs:[:amount | amount] convertionFromBaseAs: [:amount | amount] ! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:28'!
centimeter

	^SimpleUnit newWithName: 'centimeter' domain: #Distance convertionToBaseAs:[:amount | amount/100] convertionFromBaseAs: [:amount | amount*100]! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:01'!
cubicMeter
	
	^CompoundUnit newWithFirstUnit: self squaredMeter secondUnit: self meter operator: #*! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:28'!
day

	^SimpleUnit newWithName: 'day' domain: #TimeMeasure convertionToBaseAs:[:amount | amount*60*60*24] convertionFromBaseAs: [:amount | amount/(60*60*24)]! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:28'!
decameter

	^SimpleUnit newWithName: 'decameter' domain: #Distance convertionToBaseAs:[:amount | amount*10] convertionFromBaseAs: [:amount | amount/10]! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:28'!
decimeter

	^SimpleUnit newWithName: 'decimeter' domain: #Distance convertionToBaseAs:[:amount | amount/10] convertionFromBaseAs: [:amount | amount*10]! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:28'!
fahrenheit

	^SimpleUnit newWithName: 'fahrenheit' domain: #Temperature convertionToBaseAs:[:amount | (amount-32) * 5/9] convertionFromBaseAs: [:amount | (amount * 9/5) + 32]! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:28'!
hectometer

	^SimpleUnit newWithName: 'hectometer' domain: #Distance convertionToBaseAs:[:amount | amount*100] convertionFromBaseAs: [:amount | amount/100]! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:28'!
hour

	^SimpleUnit newWithName: 'hour' domain: #TimeMeasure convertionToBaseAs:[:amount | amount*3600] convertionFromBaseAs: [:amount | amount/3600]! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:28'!
kelvin

	^SimpleUnit newWithName: 'kelvin' domain: #Temperature convertionToBaseAs:[:amount | amount - 273.15] convertionFromBaseAs: [:amount | amount + 273.15]! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:28'!
kilometer

	^SimpleUnit newWithName: 'kilometer' domain: #Distance convertionToBaseAs:[:amount | amount*1000] convertionFromBaseAs: [:amount | amount/1000]! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:28'!
meter
	
	^SimpleUnit newWithName: 'meter' domain: #Distance convertionToBaseAs:[:amount | amount] convertionFromBaseAs: [:amount | amount]! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:14'!
metersBySecond
	
	^CompoundUnit newWithFirstUnit: self meter secondUnit: self second operator: #/! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 15:05'!
metersBySquaredSecond
	
	^CompoundUnit newWithFirstUnit: self meter secondUnit: self squaredMeter operator: #/! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:05'!
metersTimesSecond
	
	^CompoundUnit newWithFirstUnit: self meter secondUnit: self second operator: #*! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:28'!
milimeter

	^SimpleUnit newWithName: 'milimeter' domain: #Distance convertionToBaseAs:[:amount | amount/1000] convertionFromBaseAs: [:amount | amount*1000]! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:28'!
minute

	^SimpleUnit newWithName: 'minute' domain: #TimeMeasure convertionToBaseAs:[:amount | amount*60] convertionFromBaseAs: [:amount | amount/60]! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:28'!
second
	
	^SimpleUnit newWithName: 'second' domain: #TimeMeasure convertionToBaseAs:[:amount | amount] convertionFromBaseAs: [:amount | amount]! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 12:10'!
squaredMeter
	
	^CompoundUnit newWithFirstUnit: self meter secondUnit: self meter operator: #*! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 12:13'!
squaredSecond
	
	^CompoundUnit newWithFirstUnit: self second secondUnit: self second operator: #*! !

!Unit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 15:42'!
* aMultiplier
	(aMultiplier isKindOf: Unit) 
		ifTrue: [^CompoundUnit newWithFirstUnit: self secondUnit: aMultiplier operator: #*].
	
	 (aMultiplier isKindOf: Number)
		ifTrue: [^Measure newWithAmount: aMultiplier unit: self]
	! !

!Unit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 14:46'!
/ aUnit
	(self = aUnit)
		ifTrue: [^1] 
		ifFalse: [^CompoundUnit newWithFirstUnit: self secondUnit: aUnit operator: #/]! !

!Unit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/23/2012 18:53'!
< aUnit

	^coeficient < aUnit coeficient! !

!Unit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 11:45'!
= aUnit

	self subclassResponsibility 
	! !

!Unit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 15:29'!
adaptToInteger: aNumber andSend: aMessage
	
	^self perform: aMessage with: aNumber! !

!Unit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 12:46'!
convertionToBaseFunction

	self subclassResponsibility ! !

!Unit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 15:39'!
domain

	^domain! !

!Unit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 11:48'!
min: aUnit

	((self convertionToBaseFunction value: 1)  <  (aUnit convertionFromBaseFunction value: 1)) ifTrue: [^self].
	^aUnit.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/2/2012 18:59'!
name

	self subclassResponsibility ! !

!Unit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/2/2012 19:05'!
printOn: aStream

	^aStream nextPutAll: self name! !

!Unit methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/3/2012 13:24'!
type

	^domain ! !
